## files-archive

=== Makefile ===
SHELL = /bin/bash
TARGETS = metha-sync metha-cat metha-id metha-ls metha-files metha-fortune metha-snapshot
GO111MODULE = on
VERSION = 0.2.12

PKGNAME = metha

.PHONY: all
all: $(TARGETS)

$(TARGETS): %: cmd/%/main.go
	GO111MODULE=$(GO111MODULE) go get ./...
	GO111MODULE=$(GO111MODULE) CGO_ENABLED=0 go build -o $@ $<

.PHONY: test
test:
	CGO_ENABLED=0 go test -v .

.PHONY: clean
clean:
	rm -f $(TARGETS)
	rm -f $(PKGNAME)_*deb
	rm -f $(PKGNAME)-*rpm
	rm -rf packaging/deb/$(PKGNAME)/usr

.PHONY: imports
imports:
	goimports -w .

.PHONY: deb
deb: $(TARGETS)
	mkdir -p packaging/deb/$(PKGNAME)/usr/sbin
	cp $(TARGETS) packaging/deb/$(PKGNAME)/usr/sbin
	mkdir -p packaging/deb/$(PKGNAME)/usr/local/share/man/man1
	cp docs/$(PKGNAME).1 packaging/deb/$(PKGNAME)/usr/local/share/man/man1
	cd packaging/deb && fakeroot dpkg-deb --build $(PKGNAME) .
	mv packaging/deb/$(PKGNAME)_*.deb .

.PHONY: rpm
rpm: $(TARGETS)
	mkdir -p $(HOME)/rpmbuild/{BUILD,SOURCES,SPECS,RPMS}
	cp ./packaging/rpm/$(PKGNAME).spec $(HOME)/rpmbuild/SPECS
	cp $(TARGETS) $(HOME)/rpmbuild/BUILD
	cp docs/$(PKGNAME).1 $(HOME)/rpmbuild/BUILD
	./packaging/rpm/buildrpm.sh $(PKGNAME)
	cp $(HOME)/rpmbuild/RPMS/x86_64/$(PKGNAME)*.rpm .

.PHONY: update-version
update-version:
	sed -i -e 's@^const Version =.*@const Version = "$(VERSION)"@' version.go
	sed -i -e 's@^Version:.*@Version: $(VERSION)@' packaging/deb/metha/DEBIAN/control
	sed -i -e 's@^Version:.*@Version:    $(VERSION)@' packaging/rpm/metha.spec

=== extra/chocula/Makefile ===
SHELL := /bin/bash

ping.ndj:
	python filter.py < candidates.tsv | clinker -w 256 > $@

valid.tsv: ping.ndj
	jq -rc 'select(.status == 200) | .link' ping.ndj > $@

=== extra/opendoar/Makefile ===
SHELL := /bin/bash

repos.tsv:
	./fetch.sh

=== extra/pkpindex/Makefile ===
# pkp is wip

pkpindex: main.go
	go build -o $@ $<

.PHONY: clean
clean:
	rm -f pkpindex
	rm -f pkp.ndjson

pkp.ndjson: pkpindex
	./pkpindex -verbose -mssr 100 > $@

=== packaging/arch/Makefile ===
NAME = metha
VERSION = 0.2.16
RELEASE = 0

$(NAME)-$(VERSION)-$(RELEASE)-x86_64.pkg.tar.xz: PKGBUILD
	makepkg

# Note: src dir removal might require superuser (cf. go clean -modcache).
clean:
	rm -f $(NAME)-$(VERSION)-$(RELEASE)-x86_64.pkg.tar.xz
	rm -f v$(VERSION).tar.gz
	rm -rf pkg/
	rm -rf src/

=== packaging/arch/PKGBUILD ===
# Maintainer: Martin Czygan <martin.czygan@uni-leipzig.de>

pkgname=metha
pkgver=0.2.16
pkgrel=0
pkgdesc="No frills command line OAI-PMH protocol harvester and cache."
arch=('i686' 'x86_64')
url="https://github.com/miku/metha"
license=('GPL')
makedepends=('go' 'git')
options=('!strip' '!emptydirs')
source=("${url}/archive/v${pkgver}.tar.gz")
sha256sums=('90d63ddee60059c0c8e1d9b70054d2deb13f3ac34d84fd1d5d41e45a18a69f1b')
_gourl='github.com/miku/metha/cmd/...'

prepare() {
  export GOPATH="${srcdir}"
  go get -u -v -f ${_gourl}
}

package() {
  install -Dm 775 "${srcdir}/bin/${pkgname}-cat" "${pkgdir}/usr/bin/${pkgname}-cat"
  install -Dm 775 "${srcdir}/bin/${pkgname}-files" "${pkgdir}/usr/bin/${pkgname}-files"
  install -Dm 775 "${srcdir}/bin/${pkgname}-fortune" "${pkgdir}/usr/bin/${pkgname}-fortune"
  install -Dm 775 "${srcdir}/bin/${pkgname}-id" "${pkgdir}/usr/bin/${pkgname}-id"
  install -Dm 775 "${srcdir}/bin/${pkgname}-ls" "${pkgdir}/usr/bin/${pkgname}-ls"
  install -Dm 775 "${srcdir}/bin/${pkgname}-sync" "${pkgdir}/usr/bin/${pkgname}-sync"
  install -Dm 775 "${srcdir}/${pkgname}-${pkgver}/docs/${pkgname}.1" "${pkgdir}/usr/share/man/man1/${pkgname}.1"
}

# vim:set ft=sh ts=2 sw=2 et:
